VERSION 5.00
Begin VB.Form frmProdSort 
   Caption         =   "Form1"
   ClientHeight    =   3465
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10380
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3465
   ScaleWidth      =   10380
   Begin VB.ComboBox cboLangID 
      Height          =   315
      Left            =   7995
      Style           =   2  'Dropdown List
      TabIndex        =   10
      Top             =   3105
      Width           =   1095
   End
   Begin VB.OptionButton opt_a_Z 
      Alignment       =   1  'Right Justify
      Caption         =   "a-Z"
      Height          =   200
      Left            =   3300
      TabIndex        =   8
      Top             =   3150
      Width           =   550
   End
   Begin VB.OptionButton opt_Z_a 
      Caption         =   "Z-a"
      Height          =   200
      Left            =   3950
      TabIndex        =   7
      Top             =   3150
      Width           =   550
   End
   Begin VB.CommandButton btnRandomize 
      Caption         =   "Randomize"
      Height          =   300
      Left            =   4500
      TabIndex        =   4
      ToolTipText     =   "Change write back loop delay"
      Top             =   3100
      Visible         =   0   'False
      Width           =   1000
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "E&xit"
      Height          =   300
      Left            =   9300
      TabIndex        =   5
      ToolTipText     =   "Exit macro"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.CommandButton btnSendToCatList 
      Caption         =   "&Write back"
      Enabled         =   0   'False
      Height          =   300
      Left            =   2150
      TabIndex        =   3
      ToolTipText     =   "Rearrange Catia list according to VB-list"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.CommandButton btnSortList 
      Caption         =   "&Sort"
      Enabled         =   0   'False
      Height          =   300
      Left            =   1100
      TabIndex        =   2
      ToolTipText     =   "Sort VB-list alphabetically"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.CommandButton btnGetList 
      Caption         =   "&Read List"
      Height          =   300
      Left            =   50
      TabIndex        =   1
      ToolTipText     =   "Read list of products from Catia"
      Top             =   3100
      Width           =   1000
   End
   Begin VB.ListBox lb_Prods 
      Height          =   2940
      IntegralHeight  =   0   'False
      Left            =   50
      TabIndex        =   0
      ToolTipText     =   "Select entry to scroll"
      Top             =   50
      Width           =   10250
   End
   Begin VB.Label lblLangID 
      Caption         =   "Catia Interface Language:"
      Height          =   195
      Left            =   6000
      TabIndex        =   9
      Top             =   3105
      Width           =   1845
   End
   Begin VB.Label lblListCount 
      Caption         =   "Entries: 0000"
      Height          =   195
      Left            =   4995
      TabIndex        =   6
      Top             =   3105
      Width           =   930
   End
End
Attribute VB_Name = "frmProdSort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'---------------------------------------------------------------------------------------
'---------------------------------------------------------------------------------------
' Project   : ProdSort
' Author    : jherzog
' Date      : 10.04.2016
' Purpose   : Sort Catia products
'---------------------------------------------------------------------------------------
'---------------------------------------------------------------------------------------
'release information: Rel. 1.4
'- form resizeable
'- form min size restricted
'- if dialog was already opened, readlist threw an error; changed
'- check workbench;
'- check part or product;
'- handle several possible user errors
'- multi-language support(StartCommand; EnumChildren)
'- bugfix for partnames including '.'
'- require models with instname = partname + index
'- ApplyWorkMode DEFAULT_MODE for all products

'---------------------------------------------------------------------------------------
'ToDo:
'- add automode:
'  - command parm '-a' -> read, sort, write back
'  - command parm '-s' -> send 'apply' to catia dialog
'  - command parm '-c' -> send 'ok' to catia dialog
'  - command parm '-m' -> accept multi-selected products
'  - Command parm '-b' -> batch mode; sort all products in dir
'  - command parm '-f' -> sort product and following loaded child products
'
'- add savesettings
'  - form position: x + y
'  - form size: w + h
'  - option a-z
'
'- optional syncing if P/N and Inst/N don't match
'

'---------------------------------------------------------------------------------------
'release information: Rel. 1.3
'
'- removed 'Command' & parm '-c'; added option buttons
'- removed delay: set delay button/delay label and sleep commands
'- added sub scramble for testing
'
'

'---------------------------------------------------------------------------------------
'release information: Rel. 1.2
'
'bugfix:
'if there was no instance number, eg. 'somepart.1', the macro would crash
'
'added:
'prodsort now accepts one parameter on pprogram start: '-c'
'this parm indicates, that sorting shound be case independent;
'if this parm is not set, 'Z' goes before 'a'.
'setting -c has no influence on the case of the catia list entries
'---------------------------------------------------------------------------------------

Sub FillCombo()
   Dim arrLang()                                           'languages
'   Dim arrCmdMain()                                        'dialog title
'   Dim arrCmdUp()                                          'up arrow caption
'   Dim arrCmdDown()                                        'down arrow caption
'   Dim arrCmdFree()                                        'free button caption

   Dim n As Integer

   arrLang = Array("English", "French", _
                   "German", "Italian")                    ', "Japanese", "Korean", "Simplified Chinese")
   arrMenu = Array("Graph tree reordering", "Rorganisation de l'arbre", _
                      "Neuordnung des Grafikbaums", "Riordino dell'albero logico")
   arrDlgTitle = Array("Graph tree reordering", "Rorganisation de l'arbre", _
                      "Neuordnung des Grafikstrukturbaums", "Riordino dell'albero logico")
   arrCmdUp = Array("Move Up", "Dplacer vers le haut.", _
                    "Nach oben verschieben", "Sposta in alto")
   arrCmdDown = Array("Move Down", "Dplacer vers le bas", _
                      "Nach unten verschieben", "Sposta in basso")
   arrCmdFree = Array("Free Move", "Dplacement libre", _
                      "Freies Verschieben", "Spostamento libero")


   For n = LBound(arrLang) To UBound(arrLang)
      cboLangID.AddItem arrLang(n)
   Next
End Sub

Private Sub PushButton(hwnd As Long)         'push catia button
   SetActiveWindow hWndDlg                   'activate dialog
   SendMessageByNum hwnd, BM_CLICK, 0&, 0&   'send click message to dialog button
End Sub

Private Sub btnExit_Click()
   Unload Me
End Sub

Private Sub btnGetList_Click()
Dim oSel As Selection

   On Error GoTo btnGetList_Click_Error
   
   If CATIA.GetWorkbenchId <> "Assembly" Then         'check for assembly workbench
      MsgBox "Please change to Assembly Workbench!", _
         vbOKOnly Or vbCritical, "GetList Check Workbench"
      Exit Sub
   End If
   
   If CATIA.Windows.Count = 0 Then
         MsgBox "No product opened!" & vbCrLf _
              & "Please open and select a product" & vbCrLf _
              & "before reading the list!", _
                vbOKOnly Or vbCritical, "ReadList"
   
      Exit Sub              'if no doc open quit
   End If
   
   Set oSel = CATIA.ActiveDocument.Selection
   If FindWindow(vbNullString, arrDlgTitle(iLangIndex)) = 0 Then    'dialog open?
      If oSel.Count2 = 0 Then                              'anything selected?
         MsgBox "No product selected!" & vbCrLf _
              & "You need to select a product" & vbCrLf _
              & "before reading the list!", _
                vbOKOnly Or vbCritical, "ReadList"
         Exit Sub

      Else
         Set oPP = oSel.Item2(1)
         oPP.Value.ApplyWorkMode DEFAULT_MODE    'set work mode to expose P/N
         Select Case oPP.Type
            Case "Product"
               'check if part or product
               If TypeName(oPP.Value.ReferenceProduct.Parent) = "ProductDocument" Then
                  CATIA.StartCommand CStr(arrMenu(iLangIndex)) '"Graph tree reordering"   'open dialog
                  CATIA.RefreshDisplay = True
               Else                                        'part instance selected
                  MsgBox "No product selected!" & vbCrLf _
                       & "You need to select a product" & vbCrLf _
                       & "before reading the list!", _
                         vbOKOnly Or vbCritical, "ReadList"
                  oSel.Clear
                  Exit Sub

               End If
            Case Else                                      'selection was not a product
               MsgBox "No product selected!" & vbCrLf _
                    & "You need to select a product" & vbCrLf _
                    & "before reading the list!", _
                      vbOKOnly Or vbCritical, "ReadList"
               oSel.Clear
               Exit Sub
         End Select
      End If
   End If

   GetProductsListFromList CStr(arrDlgTitle(iLangIndex))   '  "Graph tree reordering"
   lblListCount.Caption = "Entries: " & Format$(lb_Prods.ListCount, "0000")

   SendMessageByNum hWndUD, UDM_SETRANGE32, 0, lb_Prods.ListCount - 1

   btnSortList.Enabled = True
   btnSendToCatList.Enabled = True
'   oSel.Clear

Exit Sub
'---------------------------------------------------------------------------------------
btnGetList_Click_Error:
   Dim errMsg As String
   Dim errRet As VbMsgBoxResult

   Select Case Err.Number
'       Case 438
'       Case -2147467259                               'if part was selected
'               oPP.Value.ApplyWorkMode DEFAULT_MODE    'set work mode to expose P/N
'               Resume
       Case Else
         errMsg = Err.Number & ": " & Err.Description & " in procedure GetList"
         errRet = MsgBox(errMsg, vbOKOnly, "GetList")
   End Select

   'Resume Next                                          'fall thru to quit sub
'---------------------------------------------------------------------------------------

End Sub

Private Sub btnRandomize_Click()
   Scramble lb_Prods 'scramble listbox
End Sub

'---------------------------------------------------------------------------------------
' Procedure : btnSortList_Click
' Author    : jherzog
' Date      : 15.04.2016
' Time      : 16:14
' Languages : VB6 Pro SP6
' V5-Release: V5R19/21
' Purpose   : Prepare/create array entries and init quick sort; reorder list box entries
' Parms     : - (from dialog)
' Ret. Value: sorted list box
'
' Syntax    : -
'
' Prereqs   : filled list box
' Remarks   : Expects all products to be in workmode(ApplyWorkMode DEFAULT_MODE)
'---------------------------------------------------------------------------------------
' Version 1.4:
' Folgende Flle knnen vorkommen:
' - Instanz ohne Index; Beispiel:
'  P/N:     3491998__1500__FM_SCHILD_24X80
'  Inst/N:  3491998__1500__FM_SCHILD_24X80
'  NICHT ZULSSIG!

' - Instanzname <> P/N + Index; Beispiel:
'  P/N:     Scheibe 5.3 DIN 7349 - St
'  Inst/N:  Scheibe 5,4 DIN 7349 - St.1
'  NICHT ZULSSIG!

' - P/N mit Dezimal-Punkt im Namen; Beispiel
'  P/N:     Scheibe 5.3 DIN 7349 - St
'  ZULSSIG!
'
'
'---------------------------------------------------------------------------------------

Private Sub btnSortList_Click()
'---------------------------------------------------------------------------------------
' - Die ausgelesenen Strings mssen noch in PN und Instance/N augesplittet werden.
' - Die Instanz wird zur Sortierung auf 4 Stellen erweitert. Dazu muss sie zuerst
'   identifiziert werden.
' - Erwartbare Strings:
'   1a) 3491998__1500__FM_SCHILD_24X80[3491998__1500__FM_SCHILD_24X80.CATPart]
'   1b) Scheibe 6.4 DIN 7349 - St[Scheibe 6,4 DIN 7349 - St.CatPart]
'   1c) Scheibe 5.3 DIN 7349 - St(Scheibe 5.3 DIN 7349 - St)
'   2) Scheibe 5.3 DIN 7349 - St(Scheibe 5,4 DIN 7349 - St.1)
'   3) Scheibe 6,4 DIN 7349 - St.12[Scheibe 6,4 DIN 7349 - St.CatPart]
'
' - Unterscheidung Instanz/N - P/N:
'   - Fall 1 + 3: Split an '['
'   - Fall 2: Split an '('
'   Konsequenz: '(' im Namen muss eigens behandelt werden
'
' - Instanz identifizieren:
'   - Fall 1a: Keine Instanz angegeben; kein Punkt im Inst/Namen: Inst. = 0
'   - Fall 1b: Keine Instanz angegeben; mit Punkt im Inst/Namen: Inst. nicht feststellbar
'   - Fall 1c: Keine Instanz angegeben; mit Punkt im Inst/Namen: Inst. nicht feststellbar
'   - Fall 2: Die Zahl zwischen dem letzten Punkt '.' und der Klammer ')' des Inst/N
'   - Fall 3: Die Zahl zwischen dem letzten Punkt '.' des Inst/N und der Klammer '['
'   Fazit: Der Fall 1, insbes. 1b birgt Absturzpotential.
'          Eintrge ohne Instanz sind nicht zulssig!
'          Ausserdem: bei Inst/N <> P/N + '.' + Inst kann nicht sicher zuverlssig
'                     die Instanz bestimmt werden. Deshalb erfolgt dann Abbruch!
'
'---------------------------------------------------------------------------------------
   Dim n As Integer
   Dim iPt As Integer                                      'location of point within name
   Dim iBracket As Integer                                 'location of opening bracket within name
   Dim strInst As String                                   'instance string
   Dim strIndex As String                                  'instance index string
   Dim strPN As String                                     'product/part name
   Dim iNum As Integer
   Dim mbRet As VbMsgBoxResult
   
   For n = 0 To UBound(arrProds)                           'change instance counter to 4 digits
      'convert instance counter to 4 digits before sorting; restore before rearranging product list
      iNum = NumChrs(arrProds(n), "(")                     'check for more than one '('
      If iNum > 1 Then                                     'get middle '('
         iBracket = FindnOccurence(arrProds(n), "(", iNum \ 2 + 1)
      Else
         iBracket = InStr(arrProds(n), "(")
      End If
      strPN = Left$(arrProds(n), iBracket - 2)             'the text before the '(' - 1 space
      strInst = Mid$(arrProds(n), iBracket + 1, (Len(arrProds(n))) - iBracket - 1)   'get instance

      If Left$(strInst, Len(strPN)) <> strPN And _
         Mid$(strInst, (Len(strPN) + 1), 1) <> "." Then    'if p/N and Inst/N match

         mbRet = MsgBox("Either part and instance name don't match" & vbCrLf _
              & "or there is no instance index!" & vbCrLf _
              & "Please sync part and instance names" & vbCrLf _
              & "and then re-run this macro!" & vbCrLf & vbCrLf _
              & "Exiting sort ... ", _
                vbOKOnly Or vbCritical, _
                "Error matching Part and Instance")

'              & "Would you like to sync the instances now?", _
'                vbYesNo Or vbCritical, _
'                "Error matching Part and Instance")
'         If mbRet = vbYes Then
'           SyncInstances
'         End If
         PushButton hWndDlgCancel
         lb_Prods.Clear
         btnSortList.Enabled = False
         btnSendToCatList.Enabled = False
         Exit Sub                                          'quit sort
      End If

      iPt = InStrRev(strInst, ".")                         'get the last point
      strIndex = Right$(strInst, Len(strInst) - iPt)
      
      'format instance for sorting
      arrProds(n) = strPN & " (" & Left(strInst, iPt) & Format(strIndex, "0000") & ")"

      If opt_a_Z.Value = True Then                         'if sorting should be case independent
         arrProds(n) = UCase(arrProds(n))                  'set all entries to uppercase
      End If
   Next

   lb_Prods.Clear                                          'clear VB list
   QuickSort arrProds                                      'sort array

   For n = 0 To UBound(arrProds)                           'restore file names to original
      iPt = InStrRev(arrProds(n), ".")                     'find point
      arrProds(n) = Left$(arrProds(n), iPt) & CInt(Mid$(arrProds(n), iPt + 1, 4)) & ")"
      lb_Prods.AddItem arrProds(n)                         'add to vb list
   Next
   lblListCount.Caption = "Entries: " & Format$(lb_Prods.ListCount, "0000")
   '   btnSortList.Enabled = False
End Sub
Function NumChrs(strStrToSearch As String, strCharToSearch As String) As Integer
   Dim iStart As Integer
   Dim iNum As Integer
   
   Do
      iStart = InStr(iStart + 1, strStrToSearch, strCharToSearch)
      iNum = iNum + 1
   Loop Until iStart = 0
   NumChrs = iNum - 1

End Function
Function FindnOccurence(strStrToSearch As String, strCharToSearch As String, iOcc As Integer) As Integer
   Dim iStart As Integer
   Dim iNum As Integer
   
   Do
      iStart = InStr(iStart + 1, strStrToSearch, strCharToSearch)
      iNum = iNum + 1
      If iNum = iOcc And iStart > 0 Then
         FindnOccurence = iStart
         Exit Function
      End If
   Loop Until iStart = 0

End Function

Private Sub cboLangID_Click()
   iLangIndex = cboLangID.ListIndex

End Sub

Private Sub Form_Load()
   Dim Axl(2) As UDACCEL   'acceleration intervals

   Caption = App.EXEName & " V" & App.Major & "." & App.Minor & "." & App.Revision
   GetCatiaObjectProdSort                             'abgespecktes GetObject
      
   If CATIA Is Nothing Then                           'this should not normally happen
      Unload Me
      Exit Sub
   End If

   If (InitComctl32(ICC_UPDOWN_CLASS) = False) Then   '
      MsgBox "Can't Init Custom Controls!" & vbCrLf _
            & vbCrLf & "Exiting ...", _
            vbOKOnly Or vbCritical, "ProdSort_Load - No CC"
      Unload Me
   End If
   
   'set ud-acceleration values
   Axl(0).nSec = 1
   Axl(0).nInc = 1
'   Axl(1).nSec = 2
'   Axl(1).nInc = 2
'   Axl(2).nSec = 3
'   Axl(2).nInc = 3

   hWndUD = CreateWindowEx(0, UPDOWN_CLASS, "", WS_CHILD Or WS_VISIBLE Or UDS_ALIGNRIGHT Or UDS_WRAP, _
      0, 0, 50, 30, hwnd, ID_UD, App.hInstance, ByVal 0)
   SendMessageByNum hWndUD, UDM_SETBUDDY, lb_Prods.hwnd, 0
   SendMessageLong hWndUD, UDM_SETACCEL, ByVal 1, Axl(0)          'set up accelleration

   'bei verwendung von readallsettings entfernen
   opt_a_Z.Value = True                                           'default sorting is case independant
                                                                  'get the task bar dimensions
   Move Screen.Width - Width, Screen.Height - _
      GetTaskBarHeight * Screen.TwipsPerPixelY - Height              'move to lower right corner
   
   FillCombo
   cboLangID.Text = GetV5Lang                               'set combo acc. to interface language
   
   HookhWnd hwnd                                                  'set message hook
   SetTopMost hwnd, True                                          'set topmost
End Sub

Private Sub Form_Unload(Cancel As Integer)
   UnHookhWnd hwnd
   SetTopMost hwnd, False           'reset topmost
   End                              'quit
End Sub

'---------------------------------------------------------------------------------------
' Procedure : btnSendToCatList_Click
' Author    : jherzog
' Date      : 14.02.2015
' Time      : 21:49
' Languages : VB6 Pro SP6
' V5-Release: V5R19/21
' Purpose   : rearrange catia products list box according to sorted vb list box
' Parms     : -
' Ret. Value: -
'
' Syntax    : - (Press the button
'
' Prereqs   : Filled vb list box
' Remarks   :
'---------------------------------------------------------------------------------------
' Changes   : 28.03.2015   : Added delays; added LB_SETCURSEL message;
'                          : added counter + msgbox
'                          : ResizeDialogWindow removed
'---------------------------------------------------------------------------------------
Private Sub btnSendToCatList_Click()
   Dim iOldPos As Integer
   Dim n As Integer
   Dim lRet As Long
   
   btnGetList.Enabled = False          'no reentry please
   btnSortList.Enabled = False
   btnSendToCatList.Enabled = False
   
   If FindWindow(vbNullString, arrDlgTitle(iLangIndex)) = 0 Then    'dialog still open?
      MsgBox "'Graph tree reordering' dialog not open!" & vbCrLf _
         & "Please reselect the product and re-read the list!", _
         vbOKOnly Or vbCritical, "SendToCatList"
         btnGetList.Enabled = True
         Exit Sub
   End If
   
   MousePointer = vbHourglass
   
   For n = 0 To lb_Prods.ListCount - 1 'work thru sorted vb-list
      iOldPos = SendMessageString(hWndListBox, LB_SELECTSTRING, -1&, lb_Prods.List(n))
      If iOldPos = n Then GoTo Skip 'skip if pos is already correct
      ClickListItem iOldPos            'select the element to move
      CATIA.RefreshDisplay = True
      PushFreeMove                     'select free move button
      lRet = SendMessageByNum(hWndListBox, LB_SETCURSEL, n, 0&)
      If lRet < 0 Then MsgBox "error"
      ClickListItem n                  'select destination
      CATIA.RefreshDisplay = True
Skip:
      lblListCount.Caption = "Entries: " & Format$(n + 1, "0000")
   Next
   
   MousePointer = vbNormal
   
   btnGetList.Enabled = True           'back to normal
   btnSortList.Enabled = True
   btnSendToCatList.Enabled = True
   MsgBox "Sort finished!" & vbCrLf & _
      "Don't forget to save!", vbOKOnly Or vbInformation, "SendToCatList"
End Sub

Sub SyncInstances()
   Dim oRootProds As Products
'   Dim oSel As Selection
'   Dim oPP

'   CATIA.Interactive = False                               'no interaction allowed

'   Set oSel = CATIA.ActiveDocument.Selection
'   If oSel.Count2 = 0 Then                                 'anything selected?
'      MsgBox "No product selected!" & vbCrLf _
'           & "You need to select a product" & vbCrLf _
'           & "before reading the list!", _
'             vbOKOnly Or vbCritical, "ReadList"
'      Exit Sub
'   Else
'      Set oPP = oSel.Item2(1)

      Select Case oPP.Type
         Case "Product"
            'check if part or product
            If TypeName(oPP.Value.ReferenceProduct.Parent) = "ProductDocument" Then
               CATIA.StatusBar = oPP.Value.Name & ": Renaming instances ..."

               oPP.Value.ApplyWorkMode DEFAULT_MODE        'set work mode to expose P/N

               Set oRootProds = oPP.Value.ReferenceProduct.Products
               CATIA.StatusBar = oPP.Value.Name & ": Renaming instances ... First pass ..."
               InstanceEqualName oRootProds, True          'first pass to clear low numbers

               CATIA.StatusBar = oPP.Value.Name & ": Renaming instances ... Second pass ..."
               InstanceEqualName oRootProds, False         'second pass to sort instances

               CATIA.StatusBar = oPP.Value.Name & ": Renaming instances ... Done."

            Else                                           'part instance selected
               MsgBox "No product selected!" & vbCrLf _
                    & "You need to select a product" & vbCrLf _
                    & "before reading the list!", _
                      vbOKOnly Or vbCritical, "ReadList"
'               oSel.Clear
               Exit Sub

            End If
         Case Else                                         'selection was not a product
            MsgBox "No product selected!" & vbCrLf _
                 & "You need to select a product" & vbCrLf _
                 & "before reading the list!", _
                   vbOKOnly Or vbCritical, "ReadList"
'            oSel.Clear
            Exit Sub
      End Select
'   End If

'   CATIA.Interactive = True                                'allow interaction

End Sub

'---------------------------------------------------------------------------------------
' Procedure : InstanceEqualName
' Author    : jherzog
' Date      : 19.04.2016
' Time      : 20:00
' Languages : VBA 6.5
' V5-Release: V5R19/21
' Purpose   : Rename product instances to match part name,
'           : while sorting the instances within a product
' Parms     : oProducts: Node of products, eg. 'CATIA.ActiveDocument.Product.Products'
'           : bFirstPass: indicates if first or second pass
' Ret. Value: -
'
' Syntax    : InstanceEqualName oMainProducts, True
'
' Prereqs   : an opened product
' Remarks   :
'---------------------------------------------------------------------------------------
'
Sub InstanceEqualName(oProducts As Products, bFirstPass As Boolean)

   Dim strPNum As String
   Dim strPName As String
   Dim iPos As Integer
   Dim n As Integer
   Dim oinstance As Product


   On Error GoTo InstanceEqualName_Error

   For n = 1 To oProducts.Count

      Set oinstance = oProducts.Item(n)                    'get a product/part
      strPNum = oinstance.PartNumber                       'get part number
'      strPName = oinstance.Name                            'this is the name to change

      If bFirstPass = True Then
         iPos = oProducts.Count + 1                        'first pass clear 'count' positions
      Else
         iPos = 1                                          'second pass assign instances
      End If

      'this causes an error if the instance already exists
      oinstance.Name = strPNum & "." & iPos                'rename instance
      DoEvents
   Next

   Exit Sub
   '---------------------------------------------------------------------------------------
InstanceEqualName_Error:
   Dim errMsg As String
   Dim errRet As VbMsgBoxResult

   Select Case Err.Number
      Case -2147467259                                     'couldn't rename instance
         iPos = iPos + 1                                   'increase instance counter
         Resume                                            'try again
      Case Else
         errMsg = Err.Number & ": " & Err.Description & " in procedure InstanceEqualName"
         errRet = MsgBox(errMsg, vbOKOnly, "InstanceEqualName")
   End Select

   'Resume Next                                             'fall thru to quit sub
   '---------------------------------------------------------------------------------------
End Sub

'click an entry in the catia 'Graph tree reordering' list box
'---------------------------------------------------------------------------------------
Private Sub ClickListItem(iItem As Integer)
   Dim rc As RECT
   Dim lParam As Long
   
   SendMessageAny hWndListBox, LB_GETITEMRECT, ByVal CLng(iItem), rc 'get size/position
   'send button-down/button-up combo
   lParam = MAKELPARAM((rc.Right - rc.Left) \ 2, rc.Top + (rc.Bottom - rc.Top) \ 2)
   SendMessageByNum hWndListBox, WM_LBUTTONDOWN, 0&, lParam
   SendMessageByNum hWndListBox, WM_LBUTTONUP, 0&, lParam
End Sub

'push the catia 'Free Move' button
Private Sub PushFreeMove()
   SendMessageByNum hWndLBFreeMove, BM_CLICK, 0&, 0&  'send click message
End Sub

Private Sub lb_Prods_Click()
   SendMessageByNum hWndUD, UDM_SETPOS32, 0&, MAKELPARAM(lb_Prods.ListIndex, 0&)
End Sub

Private Sub Form_Resize()
   Dim l As Single
   Dim t As Single
   Dim w As Single
   Dim h As Single
   Dim s As Single
   
   s = 50
   
   'listbox
   l = s
   t = s
   w = ScaleWidth - 2 * s
   h = ScaleHeight - btnExit.Height - 3 * s
   lb_Prods.Move l, t, w, h
   
   'up-down control
   SendMessageByNum hWndUD, UDM_SETBUDDY, lb_Prods.hwnd, 0
   
   'buttons
   t = ScaleHeight - btnExit.Height - s
   btnGetList.Move l, t
   
   l = btnGetList.Left + btnGetList.Width + s
   btnSortList.Move l, t
   
   l = btnSortList.Left + btnSortList.Width + s
   btnSendToCatList.Move l, t
   
   l = ScaleWidth - btnExit.Width - s
   btnExit.Move l, t
   
   'option button
   l = btnSendToCatList.Left + btnSendToCatList.Width + s * 3
   opt_a_Z.Move l, t + s
   
   l = opt_a_Z.Left + opt_a_Z.Width + s
   opt_Z_a.Move l, t + s
   
   'label
   l = opt_Z_a.Left + opt_Z_a.Width + s * 5
   lblListCount.Move l, t + s
   
   l = lblListCount.Left + lblListCount.Width + s * 5
   lblLangID.Move l, t + s
   
   'combo
   l = lblLangID.Left + lblLangID.Width + s
   cboLangID.Move l, t
End Sub

'Sub SaveAllSettings()
'
'   SaveSetting App.Title, "Settings", "SortOrder", opt_a_Z.Value
'
'   SaveSetting App.Title, "Settings", "MainLeft", Me.Left
'   SaveSetting App.Title, "Settings", "MainTop", Me.Top
'   SaveSetting App.Title, "Settings", "MainWidth", Me.Width
'   SaveSetting App.Title, "Settings", "MainHeight", Me.Height
'
''---------------------------------------------------------------------------------------
'End Sub
'Sub ReadSettings()
'
'   'read settings from regisry and adjust controls accordingly; if
'   'the macro crashes, the cbo.listindex values are set to -1(none selected)
'   On Error GoTo ReadSettings_Error
'
'
'
'
'
''   Me.Left = GetSetting(App.Title, "Settings", "MainLeft", l)        'read last saved
''   Me.Top = GetSetting(App.Title, "Settings", "MainTop", t)          'position
''
''   Move Me.Left, Me.Top                                              'move it
''
''   Move Screen.Width - Width, Screen.Height - _
''      GetTaskBarHeight * Screen.TwipsPerPixelY - Height              'move to lower right corner
''
''
''
''   optLead(1).Value = GetSetting(App.Title, "Settings", "LeadTrail")
''   optLead(0).Value = Not optLead(1).Value
'
'Exit Sub
''--------------------------------------------------------------------------------------------------------------------
'ReadSettings_Error:
'   Dim errMsg As String
'   Dim errRet As VbMsgBoxResult
'
'   Select Case Err.Number
'       Case 13                                           'type mismatch
'         Resume Next
''       Case -2147467259
'       Case Else
'         'timer not running yet
'         errMsg = Err.Number & ": " & Err.Description & " in procedure ReadSettings"
'         errRet = MsgBox(errMsg, vbOKOnly, "ReadSettings")
'   End Select
'
'   'Resume Next                                          'fall thru to quit sub
''--------------------------------------------------------------------------------
'
'End Sub

