Attribute VB_Name = "modGetLang"
Option Explicit

Private Declare Function GetUserDefaultLangID Lib "kernel32" () As Integer
Private Declare Function GetSystemDefaultLangID Lib "kernel32" () As Integer

'   MsgBox GetV5Lang
'   Kill CATIA.SystemService.Environ("CATTEMP") & "\FrameGeneral.xml"

Function UserDefLang() As String
   Select Case LoByte(GetUserDefaultLangID)
   
      Case 4
         UserDefLang = "Simplified Chinese"
      Case 7
         UserDefLang = "German"
      Case 9
         UserDefLang = "English"
      Case 10
         UserDefLang = "Spanish"
      Case 12
         UserDefLang = "French"
      Case 16
         UserDefLang = "Italian"
      Case 17
         UserDefLang = "Japanese"
      Case 18
         UserDefLang = "Korean"
      Case Else
         MsgBox "LangID: " & LoByte(GetSystemDefaultLangID)
   End Select

End Function

Function HiByte(ByVal wParam As Long) As Integer
    HiByte = wParam \ &H100 And &HFF&
End Function

Function LoByte(ByVal wParam As Long) As Integer
    LoByte = wParam And &HFF&
End Function

Public Function GetV5Lang() As String
   Dim shelltext As String
   Dim strFileTxt As String
   Dim strTmp As String
   Dim iLangCode As Integer
   Dim sLanguage As String

   shelltext = Chr(34) & CATIA.SystemService.Environ("CATDLLPATH") & _
               "\CATBatGenXMLSet.exe" & Chr(34) & " " & Chr(34) & _
               CATIA.SystemService.Environ("CATTEMP") & Chr(34) & " FrameGeneral"

   Shell shelltext, vbHide
   DoEvents
   Sleep 100                                    'wait for shell to finish

   strFileTxt = txt_ReadAll(CATIA.SystemService.Environ("CATTEMP") & _
                         "\FrameGeneral.xml")
   
   strTmp = LTrim2(strFileTxt, InStr(strFileTxt, "UserInterfaceLanguage"))
   strTmp = Left(strTmp, InStr(strTmp, "</Attribute>") - 1)
   If InStr(strTmp, "<Value>") = 0 Then
      'value 4 lang not found
      Exit Function
   End If

   strTmp = LTrim2(strTmp, InStr(strTmp, "<Value>") + 6)
   iLangCode = CInt(RTrim2(strTmp, Len(strTmp) - InStr(strTmp, "</Value>") + 1))

   Select Case iLangCode
      Case 0
         'sLanguage = "System Default"
         sLanguage = UserDefLang
      Case 714
         sLanguage = "English"
      Case 598
         sLanguage = "French"
      Case 602
         sLanguage = "German"
      Case 706
         sLanguage = "Italian"
      Case 807
         sLanguage = "Japanese"
      Case 608
         sLanguage = "Korean"
      Case 1828
         sLanguage = "Simplified Chinese"
   End Select
   
   GetV5Lang = sLanguage
   
   Kill CATIA.SystemService.Environ("CATTEMP") & "\FrameGeneral.xml"

End Function

Private Function txt_ReadAll(ByVal sFilename As String) As String

  Dim F As Integer
  Dim sInhalt As String

  ' Existiert die Datei ?
  If Dir$(sFilename, vbNormal) <> "" Then
    ' Textdatei im Binrmodus ffnen und gesamten
    ' Inhalt in einem Rutsch auslesen
    F = FreeFile
    Open sFilename For Binary As #F
    sInhalt = Space$(LOF(F))
    Get #F, , sInhalt
    Close #F
  End If

  txt_ReadAll = sInhalt
End Function

Private Function LTrim2(ByVal str As String, ByVal dig As Integer)
    LTrim2 = Right(str, Len(str) - dig)
End Function

Private Function RTrim2(ByVal str As String, ByVal dig As Integer)
    RTrim2 = Left(str, Len(str) - dig)
End Function



