Attribute VB_Name = "modSysMetrics"
Option Explicit
'**********************************
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
'**********************************
'** sysmet Constant Definitions:

Public Const SM_ARRANGE As Long = 56                   'Flags that set how Windows arranges minimized windows. See the ARW constants in file api32.txt for details.
Public Const SM_CLEANBOOT As Long = 67                 'Boot mode. 0 = normal, 1 = safe, 2 = safe with network.
Public Const SM_CMETRICS As Long = 44                  'Number of available system metrics.
Public Const SM_CMOUSEBUTTONS As Long = 43             'Number of mouse buttons. Zero if no mouse.
Public Const SM_CXBORDER As Long = 5                   'Dimensions of nonsizeable borders
Public Const SM_CXCURSOR As Long = 13                  'Standard cursor dimensions
Public Const SM_CXDLGFRAME As Long = 7                 'Dimensions of dialog box borders
Public Const SM_CXDOUBLECLK As Long = 36               'Size of double click area
Public Const SM_CXDRAG As Long = 68                    '
Public Const SM_CXEDGE As Long = 45                    '
Public Const SM_CXFIXEDFRAME As Long = SM_CXDLGFRAME   '
Public Const SM_CXFRAME As Long = 32                   'Dimensions of sizeable border (use SM_C?FIXEDFRAME for Win 95  as long NT 4.0).
Public Const SM_CXFULLSCREEN As Long = 16              'Size of client area of maximized window
Public Const SM_CXHSCROLL As Long = 21                 'Dimensions of arrow on horizontal scroll bar
Public Const SM_CXHTHUMB As Long = 10                  'Dimensions of scroll box on horizontal scroll bar
Public Const SM_CXICON As Long = 11                    'Size of standard icon
Public Const SM_CXICONSPACING As Long = 38             'Space between desktop icons. Large icon spacing for Win95  as long NT4.0.
Public Const SM_CXMAXIMIZED As Long = 61               'Default size of maximized window
Public Const SM_CXMAXTRACK As Long = 59                'Maximum tracking width when resizing window.
Public Const SM_CXMENUCHECK As Long = 71               'Size of menu checkmark bitmap
Public Const SM_CXMENUSIZE As Long = 54                'Size of button on menu bar
Public Const SM_CXMIN As Long = 28                     'Minimum size of a window
Public Const SM_CXMINIMIZED As Long = 57               'Rectangle in which minimized windows must fit. Smaller or equal
                                                'to SM_C?ICONSPACING.
Public Const SM_CXMINSPACING As Long = 47              '
Public Const SM_CXMINTRACK As Long = 34                'Minimum tracking size of window
Public Const SM_CXSCREEN As Long = 0                   'Size of screen
Public Const SM_CXSIZE As Long = 30                    'Size of title bar bitmaps
Public Const SM_CXSIZEFRAME As Long = SM_CXFRAME       'Size of window with WS_THICKFRAME style
Public Const SM_CXSMICON As Long = 49                  'Size of small icon
Public Const SM_CXSMSIZE As Long = 52                  'Size of small caption button
Public Const SM_CXVSCROLL As Long = 2                  'Size of arrow in vertical scroll bar
Public Const SM_CYBORDER As Long = 6                   'Dimensions of nonsizeable borders
Public Const SM_CYCAPTION As Long = 4                  'Height of window caption
Public Const SM_CYCURSOR As Long = 14                  'Standard cursor dimensions
Public Const SM_CYDLGFRAME As Long = 8                 'Dimensions of dialog box borders
Public Const SM_CYDOUBLECLK As Long = 37               'Size of double click area (see comments)
Public Const SM_CYDRAG As Long = 69                    '
Public Const SM_CYEDGE As Long = 46                    '
Public Const SM_CYFIXEDFRAME As Long = SM_CYDLGFRAME   '
Public Const SM_CYFRAME As Long = 33                   'Dimensions of sizeable border (use SM_C?FIXEDFRAME for Win 95 as long NT 4.0).
Public Const SM_CYFULLSCREEN As Long = 17              'Size of client area of maximized window
Public Const SM_CYHSCROLL As Long = 3                  'Dimensions of arrow on horizontal scroll bar
Public Const SM_CYICON As Long = 12                    'Size of standard icon
Public Const SM_CYICONSPACING As Long = 39             'Space between desktop icons. Large icon spacing for Win95  as long NT4.0.
Public Const SM_CYKANJIWINDOW As Long = 18             'Height of Kanji window
Public Const SM_CYMAXIMIZED As Long = 62               'Default size of maximized window
Public Const SM_CYMAXTRACK As Long = 60                'Maximum tracking width when resizing window.
Public Const SM_CYMENU As Long = 15                    'Height of menu
Public Const SM_CYMENUCHECK As Long = 72               'Size of menu checkmark bitmap
Public Const SM_CYMENUSIZE As Long = 55                'Size of button on menu bar
Public Const SM_CYMIN As Long = 29                     'Minimum size of a window
Public Const SM_CYMINIMIZED As Long = 58               'Rectangle in which minimized windows must fit. Smaller or equal
                                                       'to SM_C?ICONSPACING.
Public Const SM_CYMINSPACING As Long = 48              '
Public Const SM_CYMINTRACK As Long = 35                'Minimum tracking size of window
Public Const SM_CYSCREEN As Long = 1                   'Size of screen
Public Const SM_CYSIZE As Long = 31                    'Size of title bar bitmaps
Public Const SM_CYSIZEFRAME As Long = SM_CYFRAME       'Size of window with WS_THICKFRAME style
Public Const SM_CYSMCAPTION As Long = 51               'Height of small caption
Public Const SM_CYSMICON As Long = 50                  'Size of small icon
Public Const SM_CYSMSIZE As Long = 53                  'Size of small caption button
Public Const SM_CYVSCROLL As Long = 20                 'Size of arrow in vertical scroll bar
Public Const SM_CYVTHUMB As Long = 9                   'Height of scroll box on vertical scroll bar
Public Const SM_DBCSENABLED As Long = 42               'TRUE if double byte characters are supported
Public Const SM_DEBUG As Long = 22                     'TRUE if debugging version of Windows is running
Public Const SM_MENUDROPALIGNMENT As Long = 40         'Zero if popup menus are aligned to the left of the menu bar item,
                                                       'TRUE if the popup menu is aligned to the right of the menu bar item
Public Const SM_MIDEASTENABLED As Long = 74            'Hebrew and Arabic enabled.
Public Const SM_MOUSEPRESENT As Long = 19              'TRUE if a mouse is present
Public Const SM_NETWORK As Long = 63                   'Bit 0 is set if a network is present. Other bits are reserved.
Public Const SM_PENWINDOWS As Long = 41                'The handle of the pen windows supports DLL if loaded
Public Const SM_RESERVED1 As Long = 24                 '
Public Const SM_RESERVED2 As Long = 25                 '
Public Const SM_RESERVED3 As Long = 26                 '
Public Const SM_RESERVED4 As Long = 27                 '
Public Const SM_SECURE As Long = 44                    'True if security is present.
Public Const SM_SLOWMACHINE As Long = 73               'System is too slow for effective use but is being run anyway
Public Const SM_SWAPBUTTON As Long = 23                'TRUE if left and right mouse buttons are swapped

Public Const SM_SHOWSOUNDS As Long = 70
Public Const SM_MOUSEWHEELPRESENT As Long = 75

